"use strict";
const index = require("../index");
const useEventListener = require("../useEventListener");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const useEventListener__default = /* @__PURE__ */ _interopDefaultLegacy(useEventListener);
function useHover(target, options) {
  const { onEnter, onLeave, onChange } = options || {};
  const [state, { setTrue, setFalse }] = index.useBoolean(false);
  useEventListener__default.default(
    "mouseenter",
    () => {
      onEnter == null ? void 0 : onEnter();
      setTrue();
      onChange == null ? void 0 : onChange(true);
    },
    {
      target
    }
  );
  useEventListener__default.default(
    "mouseleave",
    () => {
      onLeave == null ? void 0 : onLeave();
      setFalse();
      onChange == null ? void 0 : onChange(false);
    },
    {
      target
    }
  );
  return state;
}
module.exports = useHover;
