"use strict";
const useAutoRunPlugin = require("./plugins/useAutoRunPlugin");
const useCachePlugin = require("./plugins/useCachePlugin");
const useDebouncePlugin = require("./plugins/useDebouncePlugin");
const useLoadingDelayPlugin = require("./plugins/useLoadingDelayPlugin");
const usePollingPlugin = require("./plugins/usePollingPlugin");
const useRefreshOnWindowFocusPlugin = require("./plugins/useRefreshOnWindowFocusPlugin");
const useRetryPlugin = require("./plugins/useRetryPlugin");
const useThrottlePlugin = require("./plugins/useThrottlePlugin");
const useRequestImplement = require("./useRequestImplement");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const useAutoRunPlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useAutoRunPlugin);
const useCachePlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useCachePlugin);
const useDebouncePlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useDebouncePlugin);
const useLoadingDelayPlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useLoadingDelayPlugin);
const usePollingPlugin__default = /* @__PURE__ */ _interopDefaultLegacy(usePollingPlugin);
const useRefreshOnWindowFocusPlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useRefreshOnWindowFocusPlugin);
const useRetryPlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useRetryPlugin);
const useThrottlePlugin__default = /* @__PURE__ */ _interopDefaultLegacy(useThrottlePlugin);
const useRequestImplement__default = /* @__PURE__ */ _interopDefaultLegacy(useRequestImplement);
function useRequest(service, options, plugins) {
  return useRequestImplement__default.default(service, options, [
    ...plugins || [],
    useDebouncePlugin__default.default,
    useLoadingDelayPlugin__default.default,
    usePollingPlugin__default.default,
    useRefreshOnWindowFocusPlugin__default.default,
    useThrottlePlugin__default.default,
    useAutoRunPlugin__default.default,
    useCachePlugin__default.default,
    useRetryPlugin__default.default
  ]);
}
module.exports = useRequest;
