"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const vue = require("vue");
const isBrowser = require("./isBrowser");
const _interopDefaultLegacy = (e) => e && typeof e === "object" && "default" in e ? e : { default: e };
const isBrowser__default = /* @__PURE__ */ _interopDefaultLegacy(isBrowser);
function getTargetElement(target, defaultElement) {
  if (!isBrowser__default.default) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  let targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if (vue.isRef(target)) {
    targetElement = target.value;
  } else {
    targetElement = target;
  }
  return targetElement;
}
exports.getTargetElement = getTargetElement;
